/**
	This file is part of BUILTU.

    BUILTU is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    BUILTU is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser Public License for more details.

    You should have received a copy of the GNU Lesser Public License
    along with BUILTU.  If not, see <http://www.gnu.org/licenses/>.
    
    Copyright (C) 2005-2010 Pasko Boris
 */
package org.builtu.persistence;

import java.util.regex.Pattern;

public class OrderColumn {
	public final String column;
	public final Ordering ordering;
	
	public OrderColumn(final String column, final Ordering ordering) {
		checkSQLInjection(column);
		this.column = column;
		this.ordering = ordering;
	}
	
	private static final Pattern VALID_COLUMN = Pattern.compile("[a-zA-Z_0-9.]+");

	private static void checkSQLInjection(final String column) {
		if (!VALID_COLUMN.matcher(column).matches()) {
			throw new RuntimeException("Bad column name:'"+column+"' possible SQL injection attempt");
		}
	}

	@Override public String toString() {
		return column+' '+ordering;
	}
	
	
}
