/**
	This file is part of BUILTU.

    BUILTU is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    BUILTU is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser Public License for more details.

    You should have received a copy of the GNU Lesser Public License
    along with BUILTU.  If not, see <http://www.gnu.org/licenses/>.
    
    Copyright (C) 2005-2010 Pasko Boris
 */
package org.builtu.util.clown;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;

import org.builtu.exceptions.FatalError;


public class JDKClown implements Clown {

	@SuppressWarnings("unchecked")
	@Override public <E> E deepClone(final E o) {
		try {
			final ByteArrayOutputStream bout = new ByteArrayOutputStream();
			final ObjectOutputStream out = new ObjectOutputStream(bout);
			out.writeObject(o);
			
			final byte [] data = bout.toByteArray();
			final ByteArrayInputStream bin = new ByteArrayInputStream(data);
			final ObjectInputStream in = new ObjectInputStream(bin);
			
			return (E) in.readObject();
		} catch (final IOException e) {
			throw new FatalError(e);
		} catch (final ClassNotFoundException e) {
			throw new FatalError(e);
		}
	}

}
